<?php

class Auth extends CI_Controller
{


    public function index()
    {
        $data["title"] = '新聞文章管理系統';
        $data["brand"] = "新北程式班";
        $data["menu"] = array(
            "about"     => "說明",
            "list"     => "清單",
            "userinfo"     => "個人資訊",
            "admin"     => "系統管理",
        );

        $this->load->view('auth/login_form', $data);
    }
    /**
     * 轉向 http://openid.ntpc.edu.tw 認證
     */
    public function do_ntpc_openid()
    {
        require_once APPPATH . '../assets/openid/openid.php';
        header("Content-Type:text/html; charset=utf-8");

        try {
            $openid = new LightOpenID( 'http://localhost/ntpc_openid_login');
            if (!$openid->mode) {
                $openid->identity = 'http://openid.ntpc.edu.tw/';
                $openid->required = array(
                    'namePerson/friendly',
                    'contact/email',
                    'namePerson',
                    'birthDate',
                    'person/gender',
                    'contact/postalCode/home',
                    'contact/country/home',
                    'pref/language',
                    'pref/timezone'
                );
                header('Location: ' . $openid->authUrl());
            }
        } catch (Exception $e) {

        }
    }


        /**
         * 接收並解析 openid 回傳資料 =>
         */
    public function get_ntpc_openid()
    {
        require_once APPPATH . '../assets/openid/openid.php';

        try {
            $openid = new LightOpenID(APP_DOMAIN . '/auth/get_ntpc_openid');
            if (!$openid->mode) {
                $openid->identity = 'http://openid.ntpc.edu.tw/';
                $openid->required = array('namePerson/friendly', 'contact/email', 'namePerson', 'birthDate', 'person/gender', 'contact/postalCode/home', 'contact/country/home', 'pref/language', 'pref/timezone');
                header('Location: /');
            } elseif ($openid->mode == 'cancel') {
                echo '使用者取消';
            } else {
                if ($openid->validate()) {

                    $attr = $openid->getAttributes();
                    $arr = explode('/', $openid->identity);
                    $attr["account"] = end($arr);

                    echo '<table border="1" cellspacing="0" cellpadding="10">';
                    echo '<tr><td>帳號</td><td>' . end(array_values(explode('/', $openid->identity))) . '</td></tr>';
                    echo '<tr><td>識別碼</td><td>' . $attr['contact/postalCode/home'] . '</td></tr>';
                    echo '<tr><td>姓名</td><td>' . $attr['namePerson'] . '</td></tr>';
                    echo '<tr><td>暱稱</td><td>' . $attr['namePerson/friendly'] . '</td></tr>';
                    echo '<tr><td>性別</td><td>' . ($attr['person/gender'] == 'M' ? '男' : '女') . '</td></tr>';
                    echo '<tr><td>出生年月日</td><td>' . $attr['birthDate'] . '</td></tr>';
                    echo '<tr><td>公務信箱</td><td>' . $attr['contact/email'] . '</td></tr>';
                    echo '<tr><td>單位</td><td>' . $attr['contact/country/home'] . '</td></tr>';
                    echo '<tr><td>年級</td><td>' . substr($attr['pref/language'], 0, 2) . '</td></tr>';
                    echo '<tr><td>班級</td><td>' . substr($attr['pref/language'], 2, 2) . '</td></tr>';
                    echo '<tr><td>座號</td><td>' . substr($attr['pref/language'], 4, 2) . '</td></tr>';
                    echo '</table>';
                    echo '<p />';
                    echo '<table border="1" cellspacing="0" cellpadding="10">';
                    echo '<tr><td>單位代碼</td><td>單位名稱</td><td>身分別</td><td>職務別</td><td>職稱別</td></tr>';
                    foreach (json_decode($attr['pref/timezone']) as $item) {
                        echo '<tr>';
                        echo '<td>' . $item->id . '</td>';
                        echo '<td>' . $item->name . '</td>';
                        echo '<td>' . $item->role . '</td>';
                        echo '<td>' . $item->title . '</td>';
                        echo '<td>' . implode('、', $item->groups) . '</td>';
                        echo '</tr>';
                    }
                    echo '</table>';

                }
            }
        } catch (Exception $e) {

        }
    }


}